import { MagicString, CodeTransform } from '@vue-macros/common';
import { OptionsResolved } from './options.js';
import { FunctionDeclaration, FunctionExpression, ArrowFunctionExpression, CallExpression, Node } from '@babel/types';

type Options = {
    withDefaultsFrom?: string;
    generateRestProps?: (restPropsName: string, index: number, list: Prop[]) => string | undefined;
};
type Prop = {
    path: string;
    name: string;
    value: string;
    defaultValue?: string;
    isRest?: boolean;
    isRequired?: boolean;
};
declare function restructure(s: MagicString, node: FunctionalNode, options?: Options): Prop[];

type FunctionalNode = FunctionDeclaration | FunctionExpression | ArrowFunctionExpression;
type DefineStyle = {
    expression: CallExpression;
    isDeclaration: boolean;
    lang: string;
};
type RootMapValue = {
    defineComponent?: CallExpression;
    defineModel?: {
        expression: CallExpression;
        isRequired: boolean;
    }[];
    defineSlots?: CallExpression;
    defineExpose?: CallExpression;
    defineStyle?: DefineStyle[];
};
declare function transformJsxMacros(code: string, id: string, importMap: Map<string, string>, options: OptionsResolved): CodeTransform | undefined;
declare function isFunctionalNode(node?: Node | null): node is FunctionalNode;
declare function getMacroExpression(node: Node, options: OptionsResolved): CallExpression | undefined;
declare function getParamsStart(node: FunctionalNode, code: string): number;

export { type DefineStyle, type FunctionalNode, type RootMapValue, getMacroExpression, getParamsStart, isFunctionalNode, restructure, transformJsxMacros };
