import { MarkRequired, BaseOptions } from '@vue-macros/common';

type Options = BaseOptions & {
    lib?: 'vue' | 'vue/vapor' | (string & {});
    defineComponent?: {
        alias: string[];
    };
    defineModel?: {
        alias: string[];
    };
    defineExpose?: {
        alias: string[];
    };
    defineSlots?: {
        alias: string[];
    };
    defineStyle?: {
        alias: string[];
    };
};
type OptionsResolved = MarkRequired<Options, 'include' | 'version' | 'lib' | 'defineComponent' | 'defineModel' | 'defineExpose' | 'defineSlots' | 'defineStyle'>;
declare function resolveOptions(options: Options): OptionsResolved;

export { type Options, type OptionsResolved, resolveOptions };
